import sys
import math
import itertools#Can use for Increment 'Q'
import scipy##Use for Complex Eq
import numpy as np#Not Yet Req 
from decimal import Decimal, localcontext#Not Req 
from collections import OrderedDict
from math import sqrt
from math import floor
# Interpretation of " Solving the generalized Pell equation x^2 −Dy^2 = N "
# by John.P.Robertson(2004). Python Code by Warren B.
# The Pells Eq  x^2−Dy^2 = ±1, for x^2−Dy^2 =±4, Is 14/08/2019, Ok for given Data Sets.
# Check with K.Matthews Online Calc for further Data Sets. (Ie check solutions for Bugs!)
#Tested Examples for,PQa via LMM 'John Robinson'  x^2 - 13y^2 = 108,x^2 - 221y^2 = 217,
#x^2 - 79y^2 = 101, x^2 - 13y^2 = 101. ##These I have had working,Present Version,
##This is Manual Data Loading, Prior to Co-Processing Calls, Yield Generator,
##Simultaneous Solutions. Ie Requires different techniques to do large solutions !
##x^2 −Dy^2 = N, for a 'Shors Algorithm' type Quantum 'Modulo Expondential' example.
#Option 7. 'Karatsuba'See Page 14/"Quantum Computing and Shor‘s Factoring Algorithm"
#I.V.Volovich. 2001. 6.Modular Expondentiation.(Or Genealogy Research button, my Web Site)
#Paste Required Imports into Python 'Idle' prompt >> first
#Paste individual def code for Menu into Python Idle
#To run menu,>> main_Pell_Cubic()
def main_Pell_Cubic():
    loop_conditionN = True
    while loop_conditionN == True:
        print ("PQa via LMM")
        print ("x^2 - D*y^2 = N.")
        print ("Choose 'PQa' Options. 1 to 7")
        print ("1. D = ? ,x^2 - D*y^2 = +-1")
        print ("2. D = ? ,x^2 - D*y^2 = +-4")
        print ("3. D = ? ,x^2 - D*y^2 = +-N, Requires Options 4,5,6")
        print ("4. List of f^2 divides N")
        print ("5. For each List of f^2, finds all PZ ")
        print ("6. For each List of f^2, finds all PZ ")
        print ("7. Karatsuba")
        print ("8. Exit")
        MainChoicePell = int(input("Choose an Option:   "))
        if (MainChoicePell == 8):
            loop_conditionN = False
            break
        elif (MainChoicePell == 1):
            print ("1---------")
            PZ = 0
            Q0D = 1
            K_StepEnd1 = 8
            DO = int(input("For D >= 2. Input D for 'x^2 - D*y^2 = +-1' "))
            ret_val1 = CFforDPells(DO,PZ,Q0D,K_StepEnd1)
            print(ret_val1)
        elif (MainChoicePell == 2):
            print ("2----------")
            PZ = 1
            Q0D = 2
            K_StepEnd1 = 8
            DO = int(input("For D >= 2. Input D for 'x^2 - D*y^2 = +-4' "))
            ret_val1 = CFforDPells(DO,PZ,Q0D,K_StepEnd1)
            print(ret_val1)
        elif (MainChoicePell == 3):
            print ("3----------#")
            print("PQa with LMM. Requires Choice's 4 then (5 or 6) Solutions")
            PZ = int(input(" Input PZ('Z') for 'x^2 - D*y^2 = +- N' "))
            Q0D = int(input(" Input Qo('N') for 'x^2 - D*y^2 = +- N' "))
            DO = int(input("For D >= 2. Input D for 'x^2 - D*y^2 = +- N' "))
            K_StepEnd1 = 8
            (Solution_Set3),(Solution_Set4) = CFforDPells(DO,PZ,Q0D,K_StepEnd1)
            print(Solution_Set3)
            print(Solution_Set4)
        elif (MainChoicePell == 4):
            print ("4----------")
            NnumbPQa = int(input(" Input 'N' for 'x^2 - D*y^2 = +- N' "))
            ret_val2 = fsquare1(NnumbPQa)
            print(ret_val2)
        elif (MainChoicePell == 5):
            print ("5----------")
            print ("This returns 'Z' for 'PZ' input PQa. LMM.")
            print ("Sometimes Option 6 'Modulo Expondentia' has more accurate solutions")
            print ("Check with Karatsuba, as per Modular Expondentia(Shor's), Code Comments!")
            DNnumb = int(input(" Input 'D' for 'x^2 - D*y^2 = +- N' "))
            FNnumb = int(input(" Input 'N/f^2',Choice 4 Data (Input 'N' if only choice 4)"))
            ret_val3 = ZMod1(FNnumb,DNnumb)
            print(ret_val3)
        elif (MainChoicePell == 6):
            print ("6----------")
            print ("This returns 'Z' for 'PZ' input PQa. LMM. Type 'Modular Expondentia'")
            print ("Option 5 can return a solution, if this doesn't")
            print ("Check with Karatsuba, as per Modular Expondentia(Shor's), Code Comments!")
            DNnumb = int(input(" Input 'D' for 'x^2 - D*y^2 = +- N' "))
            FNnumb = int(input(" Input 'N/f^2',Choice 4 Data (Input 'N' if only choice 4)"))
            ret_val3 = ZMod2(FNnumb,DNnumb)
            print(ret_val3)
        elif (MainChoicePell == 7):
            print ("7----------")
            print ("Karatsuba")
            XNnumb = int(input(" Input 'x' "))
            YNnumb = int(input(" Input 'y' "))
            ret_val4 = karat(XNnumb,YNnumb)
            print(ret_val4)
        else:
            print ("Choice Not Avail")

##Paste each def code into Python idle
            
def fsquare1(NnumbPQa):
    sqactor = []
    iNnumb = 1
    iNnumb2 = 0
    while(iNnumb * iNnumb <= NnumbPQa):
        sqfactors = iNnumb * iNnumb
        if(NnumbPQa / sqfactors == NnumbPQa // sqfactors):
            iNnumb2 = (iNnumb*iNnumb)
            sqactor.append(NnumbPQa/iNnumb2)
            print("f =",iNnumb)#results
            iNnumb += 1
        else:
            iNnumb += 1
    print("m = N/f^2","N =",NnumbPQa)#results m
    print("Required 'm' solutions are")
    return sqactor
        
##Paste each def code into Python idle

from collections import OrderedDict##see Imports at top
def ZMod1(FNnumb,DNnumb):
    ##FNnumb is 'f', DNnumb is 'D'
    #Positive Solutions, -|m|/2 < z < |m|/2
    #Reproduces LMM example x^2 - 13y^2 = 108
    #(ab) mod p = ((a mod p)*(b mod p))mod p
    #see website code explaination, warren notes
    #Improvements, some repretition of Solutions, ect.
    FNnumbaM = []
    FNnumbaM1 = []
    Z_n = 1
    C_M_Ex = 0
    k_n = 0#D 0->
    while(Z_n * Z_n <= (FNnumb/2)):#|m|/2
        sqfactors1 = Z_n * Z_n
        Z_n += 1 #Po or Z
        for k_n in range(1,FNnumb,k_n + 1):#Req Neg |m|
            if((k_n - sqfactors1)!= 0):##div by Zero?
                C_M_Ex = k_n - sqfactors1#Remainder
                if(((FNnumb*2)/(C_M_Ex))==((FNnumb*2)//(C_M_Ex))):
                    if((pow(DNnumb,1,FNnumb)) == (pow(k_n,1,FNnumb)*pow(k_n,1,FNnumb))%FNnumb):
                        if((k_n + DNnumb) <= FNnumb)and(DNnumb <= FNnumb):
                            FNnumbaM.append(k_n)
                        elif((k_n + DNnumb) >= FNnumb)and(DNnumb >= FNnumb):
                            if(C_M_Ex == 1):##Hybrid Solution as per Ex #2
                                k_n = k_n - 1##Period Solution Req's Checking
                            FNnumbaM.append(k_n)
                            break
    FNnumbaM1 = list(OrderedDict.fromkeys(FNnumbaM))
    print("The returned Data is for PQa input 'Pz'")
    print("It is of the type 'Modular Expondentia', Solution P = ' ? ' mod |m|'")
    return FNnumbaM1

##Paste each def code into Python idle

def ZMod2(FNnumb,DNnumb):
    ##FNnumb is 'f', DNnumb is 'D'
    # -|m|/2 < z < |m|/2
    #Z^2 = D(Mod |m|)
    #For the Example given LMM 'John Robinson'
    #x^2 - 13y^2 = 108, Factor 27. Return is 11 ?
    #See alternative Mod Expondentiation(Limited).
    #Ok for x^2 - 221y^2 = 217. Check Non Solutions
    FNnumbaM = []#Z Numbers
    FNnumb1 = int(FNnumb)
    Z_n = 1#from D, are an integer multiple of Mod |m|
    C_M_Ex = 0
    k_n = 0#D 0->
    while(Z_n <= FNnumb1):
        sqZ_n = Z_n * Z_n
        Z_n += 1
        if(((sqZ_n - DNnumb)/FNnumb1)==((sqZ_n - DNnumb)//FNnumb1)):
            print(Z_n - 1)
            FNnumbaM.append(Z_n - 1)
    return FNnumbaM
            
##Paste each def code into Python idle

def CFforDPells(DO,PZ,Q0D,K_StepEnd1):
    DPell = DO#("D to be entered")
    Picf = dict()# Pi
    Qicf = dict()# Qi
    aicf = dict()#ai = (Pi +√D)/Qi
    Acf_A1 = dict() #Ai
    Bcf_B1 = dict() #Bi
    Gcf_G1 = dict() #Gi
    Conj_aicfC = dict()#ai = (Pi -√D)/Qi
    Solution_Set1 =  dict()
    Solution_Set2 =  dict()
    Solution_Set3 =  dict()
    Solution_Set4 =  dict()
    Solution_Set5 =  dict()
    PoZ = PZ#("x^2 - D*y^2 = +-1",Po=0,Qo=1)
    Qo = Q0D #("x^2 - D*y^2 = +-4",Po=1,Qo=2)
    Neg4_Solution = 0
    Neg1_Solution = 0
    NegN_Solution = 0
    pur = 0
    qur = 0
    gur = 0
    n_cnt = 0
    n_cnt_p = 0
    n_cnt_i = 0
    Set3_cnt1 = 0
    Set3_cnt2 = 0
    Set3_cnt3 = 0
    aicf_ir = 0
    Counter_Lcnt = 0
    Counter_Lcnt2 = 0
    Counter_Lcnt3 = 0
    Counter_Lcnt4 = 0
    Counter_Lcnt5 = 0
    Counter_Picf = 0
    Counter_Qicf = 0
    Complex_Num1 = 0
    Complex_Num2 = 0
    Comx_Conj = 0
    Five_Modulo_8_Counter = 0#1(Mod 8)
    Modulo4_0_Counter = 0 #0(Mod 4)
    Modulo4_1_Counter = 0 #1(Mod 4)
    Modulo4_3_2_Counter = 0 #2 or 3(Mod 4)
    Mod8CStop = 0
    Mod4_Finx = 0
    Mod4_Fin = 0
    Mod4_Even_Fin = 0
    Mod4_1_Fin = 0
    Mod_Holder1 = 0
    Mod_Holder2 = 0
    Lwer_aicf = 0
    Conjugate_aicf = 0
    yneg1 = 0
    ypos1 = 0
    xneg1 = 0
    xpos1 = 0
    L_Period = 0
    L_Period1 = 0
    L_Period2 = 0
    L_PeriodTotal = 0
    L_PeriodEnd = 0
    K_Period = 0
    K_StepEnd = K_StepEnd1#Set at 8, Adjust as Req: Put in for Overflow Error. OK for- 
    K_StepE1 = 0#-Data Checked. Requires Generator Yield ect, for large Error Solutions.
    finished = True
    if(PoZ == 1)and(Qo == 2):
        Neg4_Solution = 1
    if(PoZ == 0)and(Qo == 1):
        Neg1_Solution = 1
    if((PoZ != 0)and(Qo != 1))or((PoZ != 1)and(Qo != 2)):
        NegN_Solution = 1
    if((DPell - 0)/4)==((DPell - 0)//4)and((PoZ == 1)and(Qo == 2)):
        Modulo4_0_Counter = 1 #for x,y, 0(mod 4)
        PoZ = 0 #("x^2 - D*y^2 = +-4", D eqiv 0(Mod)4
        Qo = 2
    if((PoZ == 1)and(Qo == 2)):
        if(((DPell - 2)/4)==((DPell - 2)//4)or((DPell - 3)/4)==((DPell - 3)//4)):
            Modulo4_3_2_Counter = 1#for x,y, 2 or 3(mod 4)
            PoZ = 0 #("x^2 - D*y^2 = +-4", D eqiv 2(Mod)4, D eqiv 3(Mod)4
            Qo = 1
    if((DPell - 1)/4)==((DPell - 1)//4)and((PoZ == 1)and(Qo == 2)):
        Modulo4_1_Counter = 1 #1(mod 4)
    PZp = int(PoZ)
    Q0p = int(Qo)
    Dp = sqrt(DPell)
    D0p = int(Dp)
    if Qo != 0:#Q not equal Zero and a Integer
        if DPell > 0:#rD Greater than Zero and a Integer
            if Dp*Dp != pow(DPell,2):#rD not a square
                if(pow(PZp,2)% Q0p == D0p % Q0p)and(PoZ == 0)and(Qo == 1):#Modulo
                    finished = False  #Modulo Pow(0,2)==0 ie Po == 0
                if(pow(PZp,2)% Q0p == DPell % Q0p):
                    print("N Solution")
                    finished = False
                if(Neg4_Solution == 1):#Modulo
                    if((pow(PZp,0)% Q0p) == D0p % Q0p):
                        finished = False #Lets through 0 Mod 4,
                    if((pow(PZp,1)% Q0p) == D0p % Q0p):
                        finished = False #Lets through 1 Mod 4,
                    if((pow(PZp,2)% Q0p) == D0p % Q0p):
                        finished = False #Lets through 2 Mod 4,
                    if(((pow(PZp,2)% Q0p) == D0p % Q0p)or(pow(PZp,2)% Q0p) == 1%8):
                        finished = False #(1 Mod 4)(1 Mod 8)for(5 Mod 8),
                        Five_Modulo_8_Counter = 1
                    if((pow(PZp,3)% Q0p) == D0p % Q0p):
                        finished = False #Lets through 3(Mod 4)
                while finished == False:
                    if(n_cnt == 0):
                        Picf[0] = PoZ
                        Qicf[0] = Qo
                        aicf[n_cnt] = (((Picf[n_cnt]) + sqrt(DPell))//(Qicf[n_cnt]))
                        Conj_aicfC[n_cnt] = (((Picf[n_cnt]) - sqrt(DPell))/(Qicf[n_cnt]))
                        n_cnt += 1
                    if(n_cnt >= 1):
                        Picf[n_cnt] = (aicf[n_cnt - 1]*Qicf[n_cnt - 1]) - Picf[n_cnt - 1]
                        Qicf[n_cnt] = (DPell - (Picf[n_cnt]*Picf[n_cnt]))/Qicf[n_cnt - 1]
                        aicf[n_cnt] = (((Picf[n_cnt]) + sqrt(DPell))//(Qicf[n_cnt]))
                        Lwer_aicf = aicf[n_cnt - 1]
                        Conj_aicfC[n_cnt] = (((Picf[n_cnt]) - sqrt(DPell))/(Qicf[n_cnt]))
                        Conjugate_aicf = Conj_aicfC[n_cnt - 1]#Congjugate
                        if((Picf[n_cnt] == Counter_Picf)and(Qicf[n_cnt] == Counter_Qicf)):
                            Counter_Lcnt2 += 1##jcounter
                            if(Counter_Lcnt2 > aicf_ir)and(L_Period < 4):
                                L_Period += 1 ##Code block for L Period stopping Rule.
                                L_Period1 = n_cnt##L is length min period, so if 
                                if(L_Period == 2):##i ≥ i0 and k > 0, ai+kL` = ai
                                    L_Period2 = L_Period1##So to stop req K. To stop
                                if(L_Period == 3):#beyond fundemental, req ai+kL^n
                                    L_PeriodTotal = (L_Period1 - L_Period2)
                                    K_Period = 8 * (L_Period1 + aicf_ir)
                                    if(L_PeriodTotal % 2) == 0:
                                        print("Even, L Period = ",L_PeriodTotal)
                                    else:
                                        print("Odd, L Period = ",L_PeriodTotal)
                                    L_PeriodEnd = K_Period + pow(L_PeriodTotal,3)
                                    print("L PeriodEnd = ",L_PeriodEnd)
                        if(NegN_Solution == 1):
                            if((Qicf[n_cnt] == 1)or(Qicf[n_cnt] == -1))and(Set3_cnt3 != 1):
                                Solution_Set3[n_cnt - 1] = ("Q",Qicf[n_cnt])#See J.P.Robertson. LMM
                                Set3_cnt1 += 1##The motivation for this is the Complex Conjugate
                                if(Set3_cnt1 > 1):#See Mathews LMM paper for details
                                    if(Solution_Set3[n_cnt - 1] == Solution_Set3[n_cnt - 1 - L_PeriodTotal]):
                                        Set3_cnt2 += 1
                                        if(Set3_cnt2 >= 3):
                                            Set3_cnt3 = 1
                        if(Counter_Lcnt2 > Counter_Lcnt)and(Counter_Lcnt3 < 1):
                            Counter_Lcnt3 += 1
                            if(((DPell - 1)/4)== ((DPell - 1)//4)and(Neg1_Solution == 1)):
                                Mod_Holder1 = 1
                            if(((DPell - 1)/4)== ((DPell - 1)//4)and(Neg4_Solution == 1)):
                                Mod_Holder1 = 2
                                print("Start: 1 Mod 4, x^2 - D*y^2 = +-4")
                                Modulo4_1_Counter = 1
                            if(((DPell)/4) == ((DPell)//4)and(Neg4_Solution == 1)):
                                Mod_Holder1 = 3
                                print("Start: 0 Mod 4, x^2 - D*y^2 = +-4")
                            if(((DPell - 2)/4)==((DPell - 2)//4)and(Neg4_Solution == 1)):
                                Mod_Holder1 = 4
                                print("Start: 2(Mod 4),x^2 - D*y^2 = +-4")
                            if(((DPell - 3)/4)==((DPell - 3)//4)and(Neg4_Solution == 1)):
                                Mod_Holder1 = 5
                                print("Start: 3(Mod 4),x^2 - D*y^2 = +-4")
                        if(Lwer_aicf == aicf[n_cnt])and(Counter_Lcnt4 == 0):
                            aicf_ir = n_cnt#ir    
                            Counter_Lcnt = n_cnt
                            Counter_Picf = Picf[n_cnt]#Pir
                            Counter_Qicf = Qicf[n_cnt]#Qir
                            Counter_Lcnt2 += 1
                            Counter_Lcnt4 += 1
                        if(aicf[n_cnt] < Lwer_aicf)and(Counter_Lcnt5 == 0):
                            aicf_ir = n_cnt#ir #Above Comparison(Pi +√D)/Qi
                            Counter_Lcnt = n_cnt
                            Counter_Picf = Picf[n_cnt]#Pir
                            Counter_Qicf = Qicf[n_cnt]#Qir
                            Counter_Lcnt2 += 1
                            Counter_Lcnt5 += 1
                        n_cnt += 1
                        if(n_cnt > L_PeriodEnd)and(L_Period >= 3):##number iterations.
                            finished = True## Stop depending on period,K & L,index.
                Bo, B1 = 1, 0
                Ao, A1 = 0, 1
                G0, G1 = -PoZ, Qo
                Bcf_B1[0] = Bo
                Acf_A1[0] = Ao
                Gcf_G1[0] = G0
                Bcf_B1[1] = B1
                Acf_A1[1] = A1
                Gcf_G1[1] = G1
                if(Modulo4_3_2_Counter == 1):
                    if(((DPell - 2)/4)==((DPell - 2)//4)or((DPell - 3)/4)==((DPell - 3)//4)):
                        Bcf_B1[0] = 2 #set B-2 = 2, B-1 = 0,for D eqiv 2 or 3(mod 4)
                        Bcf_B1[1] = 0
                        Gcf_G1[0] = 0 #set G-2 = 0(-Po), G-1 = 2(Qo),for D eqiv 2 or 3(mod 4)
                        Gcf_G1[1] = 2
                for n_cnt_i in aicf:
                    Bo, B1 = B1,((aicf[n_cnt_i] * B1) + Bo)
                    Ao, A1 = A1,((aicf[n_cnt_i] * A1) + Ao)
                    G0, G1 = G1,((aicf[n_cnt_i] * G1) + G0)
                    Bcf_B1[n_cnt_i] = B1
                    Acf_A1[n_cnt_i] = A1
                    Gcf_G1[n_cnt_i] = G1
                    if(n_cnt_i == 0):
                        K_StepE1 = (K_StepEnd * L_PeriodTotal)
                        print(K_StepE1,"Number Solution Steps")
                    if(((L_PeriodEnd == n_cnt_i)or(n_cnt_i >= K_StepE1))and(Neg4_Solution == 1)):
                        return(Solution_Set1)
                    if(((L_PeriodEnd == n_cnt_i)or(n_cnt_i >= K_StepE1))and(Neg1_Solution == 1)):
                        return(Solution_Set2)
                    if(((L_PeriodEnd == n_cnt_i)or(n_cnt_i >= K_StepE1))and(NegN_Solution == 1)):
                        print("Take Increment between 'Q'. Ie{ num:('Q', +-1 ), num:('Q', +-1 ).. ect")
                        print("Increment Even, Positive Solution = 1st 'Q'. Odd, Inc Negative = 2nd 'Q' ")
                        print("Then look up 'Q' position in 'x','y', solution set ","Always check solution !")
                        return(Solution_Set3),(Solution_Set4)
                    if(NegN_Solution == 1)and(n_cnt_i <= K_StepE1):
                        Solution_Set4[n_cnt_i] = "x",Gcf_G1[n_cnt_i],"y",Bcf_B1[n_cnt_i]
                    if(Neg1_Solution == 1)and(n_cnt_i <= K_StepE1):
                        if((pow((Acf_A1[n_cnt_i]),2) - DPell*(pow((Bcf_B1[n_cnt_i]),2))) == 1):
                            ypos1 = Bcf_B1[n_cnt_i]#P^2(n-1) - D*(Q^2(n-1)) =(-1)^n
                            xpos1 = Acf_A1[n_cnt_i]
                            print("x = ",xpos1,"y = ",ypos1,"Positive Solution")
                            Solution_Set2[n_cnt_i] = "Pos",xpos1,ypos1
                        if((pow((Acf_A1[n_cnt_i]),2) - DPell*(pow((Bcf_B1[n_cnt_i]),2))) == -1):
                            if(L_PeriodTotal % 2) != 0:#Odd length of period; for Pells Eq =-1
                                xneg1 = Acf_A1[n_cnt_i]#Necessary condition DPell not divisable 4
                                yneg1 = Bcf_B1[n_cnt_i]#or by a prime of form 4k + 3 !
                                print("x = ",xneg1,"y = ",yneg1,"Negative Solution")
                            Solution_Set2[n_cnt_i] = "Neg",xneg1,yneg1 
                    if(Neg4_Solution == 1)and(n_cnt_i <= K_StepE1):
                        if(((pow((Gcf_G1[n_cnt_i]),2))-DPell*(pow((Bcf_B1[n_cnt_i]),2)))== 4):
                            if(Modulo4_0_Counter == 1):#0(Mod 4)
                                xpos1 = Gcf_G1[n_cnt_i]#Minimal Solution Gl-1
                                ypos1 = Bcf_B1[n_cnt_i]#Minimal Solution Bl-1
                                if(((int(xpos1)% 2)== 0)and((int(ypos1)% 2)== 0)and(n_cnt_i >= 1)):
                                    print("x = ",xpos1,"y = ",ypos1)
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1
                                    Mod4_Fin = 1
                            if(Modulo4_1_Counter == 1)and(Five_Modulo_8_Counter == 0):#1(Mod 4)
                                xpos1 = Gcf_G1[n_cnt_i]
                                ypos1 = Bcf_B1[n_cnt_i]
                                if(((int(xpos1)% 2)== 0)and((int(ypos1)% 2)== 0)and(n_cnt_i >= 1)):
                                    print("x = ",xpos1,"y = ",ypos1,)
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1
                                    Mod4_Finx = 1
                        if(((pow((Gcf_G1[n_cnt_i]),2))-DPell*(pow((Bcf_B1[n_cnt_i]),2)))== -4):
                            if(Modulo4_0_Counter == 1):#0(Mod 4)#Odd Y Solutions
                                xneg1 = Gcf_G1[n_cnt_i]#Minimal Solution Gl-1
                                yneg1 = Bcf_B1[n_cnt_i]#Minimal Solution Bl-1
                                if(((int(yneg1)% 2)== 1)and(n_cnt_i >= 1)):
                                    print("x = ",xneg1,"y = ",yneg1,"Negative Solution")
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1,"Neg",xneg1,yneg1
                                    Mod4_Finx = 1
                            if(Modulo4_1_Counter == 1):#1(Mod 4)
                                xneg1 = Gcf_G1[n_cnt_i]#Odd Solutions 
                                yneg1 = Bcf_B1[n_cnt_i] #Odd Solutions
                                if(((int(xneg1)% 2)== 1)and((int(yneg1)% 2)== 1)and(n_cnt_i >= 1)):
                                    print("x = ",xneg1,"y = ",yneg1,"Negative Solution")
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1,"Neg",xneg1,yneg1
                                    Mod4_Finx = 1
                        if(Modulo4_3_2_Counter == 1):#2&3(Mod 4)
                            xpos1 = (2 * Gcf_G1[n_cnt_i])#x2 −Dy2 = −4 has solutions if and only if
                            ypos1 = (2 * Bcf_B1[n_cnt_i])#the equation x2 −Dy2 = −1 has solutions. 
                            if(((int(xpos1) % 2)and(int(ypos1) % 2)) == 0)and(n_cnt_i >= 1):
                                if((2*(pow(xpos1,2)))- (DPell*(2*(pow(ypos1,2))))== 8):
                                    print("x = ",xpos1,"y = ",ypos1)
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1
                                    Mod4_Fin = 1
                        if(Five_Modulo_8_Counter == 1)and(Mod4_Fin != 1):#1Mod 8 filter.
                            xpos1 = Gcf_G1[n_cnt_i]
                            ypos1 = Bcf_B1[n_cnt_i]
                            if(Mod4_1_Fin < 1):
                                Mod_Holder2 = 6
                                Mod4_1_Fin += 1
                            if(((int(xpos1)% 2)== 0)and((int(ypos1)% 2)== 0)and(n_cnt_i >= 1)):
                                if(((pow((Gcf_G1[n_cnt_i]),2))-DPell*(pow((Bcf_B1[n_cnt_i]),2)))== 4):
                                    print("x = ",xpos1,"y = ",ypos1,"Even")#Determine D eqiv 5(Mod 8)
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1
                                    Complex_Num1 = 1
                                if(Complex_Num1 == 1)&(Complex_Num2 == 0):
                                    print("(1 Mod 8)for determining(5 Mod 8) Even")
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1,"1Mod8 Solution Even"
                                    Complex_Num2 = 1
                            if(((int(xpos1)% 2)!= 0)and((int(ypos1)% 2)!= 0)and(n_cnt_i >= 1)):
                                if(((pow((Gcf_G1[n_cnt_i]),2))-DPell*(pow((Bcf_B1[n_cnt_i]),2)))== 4):
                                    print("x = ",xpos1,"y = ",ypos1,"Odd")#Determine D eqiv 5(Mod 8)
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1
                                    Complex_Num1 == 1
                                if(Complex_Num1 == 1)&(Complex_Num2 == 0):
                                    print("(1 Mod 8)for determining(5 Mod 8) Odd")
                                    Solution_Set1[n_cnt_i] = xpos1,ypos1,"1Mod8 Solution Odd"
                                    Complex_Num2 = 1

##Paste each def code into Python idle
##'Karatsuba'See Page 14/"Quantum Computing and Shor‘s Factoring Algorithm"
###I.V.Volovich. 2001. 6.Modular Expondentiation(Or Genealogy Research button, my Web Site)

def karat(x,y): ##code by Micarlise
    if len(str(x)) < 3 or len(str(y)) < 3:
        return x*y
    n = max(len(str(x)),len(str(y))) // 2
    a = x // 10**(n)
    b = x % 10**(n)
    c = y // 10**(n)
    d = y % 10**(n)
    z0 = karat(b,d)
    z1 = karat((a+b), (c+d))
    z2 = karat(a,c)
    return ((10**(2*n))*z2)+((10**n)*(z1-z2-z0))+z0


    
    
    

        
    
        
    
    
    
        
        
        
        
    
